#line 1 "ad_riscv_expand.cpp"
//
// Copyright (c) 2003, 2020, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2020, Red Hat Inc. All rights reserved.
// Copyright (c) 2020, 2022, Huawei Technologies Co., Ltd. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_riscv.hpp"
#include "oops/compressedOops.hpp"

// Register masks, one for each register class.
const RegMask _ALL_REG32_mask( 0x55555555, 0x5555555, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _INT_R10_REG_mask( 0x400, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _INT_R12_REG_mask( 0x4000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _INT_R13_REG_mask( 0x10000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _INT_R14_REG_mask( 0x40000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _ALL_REG_mask( 0xffffffff, 0xfffffff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _NON_ALLOCATABLE_REG32_mask( 0x0, 0x5511000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _NON_ALLOCATABLE_REG_mask( 0x0, 0xff33000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R10_REG_mask( 0xc00, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R11_REG_mask( 0x3000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R12_REG_mask( 0xc000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R13_REG_mask( 0x30000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R14_REG_mask( 0xc0000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R15_REG_mask( 0x300000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R16_REG_mask( 0xc00000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _METHOD_REG_mask( 0x300, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _HEAPBASE_REG_mask( 0x0, 0xc000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _JAVA_THREAD_REG_mask( 0x0, 0x3000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R28_REG_mask( 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R29_REG_mask( 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _R30_REG_mask( 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _ZR_REG_mask( 0x0, 0x300000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _THREAD_REG_mask( 0x0, 0x30000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _FP_REG_mask( 0x0, 0xc0000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _RA_REG_mask( 0x0, 0xc00000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _SP_REG_mask( 0x0, 0x3000000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _FLOAT_REG_mask( 0x0, 0x50000000, 0x55555555, 0x5555555, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _DOUBLE_REG_mask( 0x0, 0xf0000000, 0xffffffff, 0xfffffff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _VECTORA_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xffffffff, 0xffffffff, 0xffffffff, 0xfffffff, 0x0, 0x0, 0x0, 0x0 );
const RegMask _F0_REG_mask( 0x0, 0x30000000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _F1_REG_mask( 0x0, 0xc0000000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _F2_REG_mask( 0x0, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _F3_REG_mask( 0x0, 0x0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _V1_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xf, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _V2_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _V3_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xf00, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _V4_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xf000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _V5_REG_mask( 0x0, 0x0, 0x0, 0x0, 0xf0000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _REG_FLAGS_mask( 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10000000, 0x0, 0x0, 0x0, 0x0 );
const RegMask _STACK_SLOTS_mask( 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
const RegMask _STACK_OR_STACK_SLOTS_mask( 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff );
const RegMask _DYNAMIC_mask( 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 );
MachNode* loadConFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  add_req(C->mach_constant_base_node());

  return this;
}

MachNode* loadConDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  add_req(C->mach_constant_base_node());

  return this;
}

MachNode* compareAndSwapBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapBAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapSAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeINode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangeLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangeNNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangePNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangeBAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeSAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeIAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangeLAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangeNAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);

  return this;
}

MachNode* compareAndExchangePAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* weakCompareAndSwapBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapBAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapSAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL oldval
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL newval
  kill = new MachProjNode( this, 2, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 3, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* maxF_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGF));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* minF_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGF));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* maxD_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGD));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* minD_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGD));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* bytes_reverse_intNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* bytes_reverse_longNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* decodeKlass_not_nullNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* CallDynamicJavaDirectNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* CallRuntimeDirectNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* CallLeafDirectNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* CallLeafNoFPDirectNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* partialSubtypeCheckNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL tmp
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 2, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* partialSubtypeCheckVsZeroNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL result
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R15_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp
  kill = new MachProjNode( this, 2, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);

  return this;
}

MachNode* string_compareUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL tmp3
  kill = new MachProjNode( this, 7, (R30_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 8, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_compareLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL tmp3
  kill = new MachProjNode( this, 7, (R30_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 8, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_compareULNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL tmp3
  kill = new MachProjNode( this, 7, (R30_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 8, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_compareLUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL tmp3
  kill = new MachProjNode( this, 7, (R30_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 8, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexofUUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp5
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp6
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 5, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexofLLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp5
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp6
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 5, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexofULNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp5
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp6
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 5, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexof_conUUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexof_conLLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_indexof_conULNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* stringU_indexof_charNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL ch
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* stringL_indexof_charNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL ch
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* clearArray_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cnt
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL base
  kill = new MachProjNode( this, 2, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);

  return this;
}

MachNode* clearArray_imm_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL base
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 2, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_equalsLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 2, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt
  kill = new MachProjNode( this, 3, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* string_equalsUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 2, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt
  kill = new MachProjNode( this, 3, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* array_equalsBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL ary1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL ary2
  kill = new MachProjNode( this, 2, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP tmp1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGP_R13));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGP_R14));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGP_R15));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGP_R16));
  add_req(def);
  // DEF/KILL tmp5
  kill = new MachProjNode( this, 3, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* array_equalsCNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL ary1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL ary2
  kill = new MachProjNode( this, 2, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP tmp1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGP_R13));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGP_R14));
  add_req(def);
  // TEMP tmp3
  def = new MachTempNode(state->MachOperGenerator(IREGP_R15));
  add_req(def);
  // TEMP tmp4
  def = new MachTempNode(state->MachOperGenerator(IREGP_R16));
  add_req(def);
  // DEF/KILL tmp5
  kill = new MachProjNode( this, 3, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* cmpFastLockNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* cmpFastUnlockNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* vabsBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vabsSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vabsINode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vabsLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vmaxFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vmaxDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vminFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vminDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addINode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* reduce_addDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxINode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minINode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGF));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_maxDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGD));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minFNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGF));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vreduce_minDNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(FREGD));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vasrBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vasrSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vlslBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vlslSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vlsrBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vlsrSNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG));
  add_req(def);

  return this;
}

MachNode* vstring_equalsLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 2, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt
  kill = new MachProjNode( this, 3, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_equalsUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 2, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt
  kill = new MachProjNode( this, 3, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* varray_equalsBNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL ary1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL ary2
  kill = new MachProjNode( this, 2, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // DEF/KILL tmp
  kill = new MachProjNode( this, 3, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* varray_equalsCNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL ary1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL ary2
  kill = new MachProjNode( this, 2, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // DEF/KILL tmp
  kill = new MachProjNode( this, 3, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cr
  kill = new MachProjNode( this, 4, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_compareUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP v4
  def = new MachTempNode(state->MachOperGenerator(VREG_V4));
  add_req(def);
  // TEMP v5
  def = new MachTempNode(state->MachOperGenerator(VREG_V5));
  add_req(def);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_compareLNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP v4
  def = new MachTempNode(state->MachOperGenerator(VREG_V4));
  add_req(def);
  // TEMP v5
  def = new MachTempNode(state->MachOperGenerator(VREG_V5));
  add_req(def);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_compareULNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP v4
  def = new MachTempNode(state->MachOperGenerator(VREG_V4));
  add_req(def);
  // TEMP v5
  def = new MachTempNode(state->MachOperGenerator(VREG_V5));
  add_req(def);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_compareLUNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL str2
  kill = new MachProjNode( this, 3, (R13_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt2
  kill = new MachProjNode( this, 4, (INT_R14_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP v4
  def = new MachTempNode(state->MachOperGenerator(VREG_V4));
  add_req(def);
  // TEMP v5
  def = new MachTempNode(state->MachOperGenerator(VREG_V5));
  add_req(def);
  // DEF/KILL tmp1
  kill = new MachProjNode( this, 5, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL tmp2
  kill = new MachProjNode( this, 6, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);

  return this;
}

MachNode* vstring_inflateNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL src
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R10_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL dst
  kill = new MachProjNode( this, 2, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL len
  kill = new MachProjNode( this, 3, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP v1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* vencode_iso_arrayNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL src
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL dst
  kill = new MachProjNode( this, 2, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL len
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* vencode_ascii_arrayNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL src
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL dst
  kill = new MachProjNode( this, 2, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL len
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* vstring_compressNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL src
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R12_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL dst
  kill = new MachProjNode( this, 2, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL len
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* vhas_negativesNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL ary
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL len
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGLNOSP));
  add_req(def);

  return this;
}

MachNode* vstringU_indexof_charNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL ch
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);

  return this;
}

MachNode* vstringL_indexof_charNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL str1
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R11_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // DEF/KILL cnt1
  kill = new MachProjNode( this, 2, (INT_R12_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // DEF/KILL ch
  kill = new MachProjNode( this, 3, (INT_R13_REG_mask()), Op_RegI );
  proj_list.push(kill);
  // TEMP result
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGI_R10));
  add_req(def);
  // TEMP tmp1
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP tmp2
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // TEMP v1
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP v2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP v3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);

  return this;
}

MachNode* vclearArray_reg_regNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // DEF/KILL cnt
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (R29_REG_mask()), Op_RegL );
  proj_list.push(kill);
  // DEF/KILL base
  kill = new MachProjNode( this, 2, (R28_REG_mask()), Op_RegP );
  proj_list.push(kill);
  // TEMP vReg1
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(VREG_V1));
  add_req(def);
  // TEMP vReg2
  def = new MachTempNode(state->MachOperGenerator(VREG_V2));
  add_req(def);
  // TEMP vReg3
  def = new MachTempNode(state->MachOperGenerator(VREG_V3));
  add_req(def);

  return this;
}

MachNode* compareAndSwapP_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapN_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapPAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndSwapNAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeN_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeP_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapN_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangeNAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* compareAndExchangePAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // TEMP tmp
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapP_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapNAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGNNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* weakCompareAndSwapPAcq_shenandoahNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP tmp
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zLoadPNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP dst
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* zCompareAndSwapPNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zCompareAndSwapP_0Node::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zCompareAndSwapPAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zCompareAndSwapPAcq_0Node::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGINOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zCompareAndExchangePNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* zCompareAndExchangePAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP res
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);

  return this;
}

MachNode* zGetAndSetPNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP prev
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

MachNode* zGetAndSetPAcqNode::Expand(State* state, Node_List& proj_list, Node* mem) {
  Compile* C = Compile::current();
  // Add projection edges for additional defs or kills
  // TEMP prev
  MachTempNode *def;
  def = new MachTempNode(state->MachOperGenerator(IREGPNOSP));
  add_req(def);
  // DEF/KILL cr
  MachProjNode *kill;
  kill = new MachProjNode( this, 1, (REG_FLAGS_mask()), Op_RegFlags );
  proj_list.push(kill);

  return this;
}

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DRISCV64=1
#ifndef RISCV64
#  error "RISCV64 must be defined"
#endif // RISCV64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
