#line 1 "ad_riscv_gen.cpp"
//
// Copyright (c) 2003, 2020, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2020, Red Hat Inc. All rights reserved.
// Copyright (c) 2020, 2022, Huawei Technologies Co., Ltd. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_riscv.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/rootnode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode){

  switch(opcode) {
  case UNIVERSE:
    return new UniverseOper( );
  case LABEL:
    return new labelOper( );
  case SREGI:
    return new sRegIOper( );
  case SREGP:
    return new sRegPOper( );
  case SREGF:
    return new sRegFOper( );
  case SREGD:
    return new sRegDOper( );
  case SREGL:
    return new sRegLOper( );
  case METHOD:
    return new methodOper( );
  case IMMI:
    return new immIOper(_leaf->get_int() );
  case IMMI0:
    return new immI0Oper(_leaf->get_int() );
  case IMMI_1:
    return new immI_1Oper(_leaf->get_int() );
  case IMMI_M1:
    return new immI_M1Oper(_leaf->get_int() );
  case UIMMI6_GE32:
    return new uimmI6_ge32Oper(_leaf->get_int() );
  case IMMI_LE_4:
    return new immI_le_4Oper(_leaf->get_int() );
  case IMMI_16:
    return new immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new immI_24Oper(_leaf->get_int() );
  case IMMI_31:
    return new immI_31Oper(_leaf->get_int() );
  case IMMI_63:
    return new immI_63Oper(_leaf->get_int() );
  case IMMIADD:
    return new immIAddOper(_leaf->get_int() );
  case IMMISUB:
    return new immISubOper(_leaf->get_int() );
  case IMMI5:
    return new immI5Oper(_leaf->get_int() );
  case IMML5:
    return new immL5Oper(_leaf->get_long() );
  case IMML:
    return new immLOper(_leaf->get_long() );
  case IMML0:
    return new immL0Oper(_leaf->get_long() );
  case IMMP:
    return new immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP0:
    return new immP0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_1:
    return new immP_1Oper(_leaf->bottom_type()->is_ptr() );
  case IMMBYTEMAPBASE:
    return new immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
  case IMMI_16BITS:
    return new immI_16bitsOper(_leaf->get_int() );
  case IMMIPOWEROF2:
    return new immIpowerOf2Oper(_leaf->get_int() );
  case IMML_32BITS:
    return new immL_32bitsOper(_leaf->get_long() );
  case IMML_M1:
    return new immL_M1Oper(_leaf->get_long() );
  case IMML_PC_OFF:
    return new immL_pc_offOper(_leaf->get_long() );
  case IMMLADD:
    return new immLAddOper(_leaf->get_long() );
  case IMMLSUB:
    return new immLSubOper(_leaf->get_long() );
  case IMMN:
    return new immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN0:
    return new immN0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IMMD:
    return new immDOper(_leaf->getd() );
  case IMMD0:
    return new immD0Oper(_leaf->getd() );
  case IMMF:
    return new immFOper(_leaf->getf() );
  case IMMF0:
    return new immF0Oper(_leaf->getf() );
  case IMMIOFFSET:
    return new immIOffsetOper(_leaf->get_int() );
  case IMMLOFFSET:
    return new immLOffsetOper(_leaf->get_long() );
  case IMMISCALE:
    return new immIScaleOper(_leaf->get_int() );
  case IREGI:
    return new iRegIOper( );
  case IREGINOSP:
    return new iRegINoSpOper( );
  case IREGI_R10:
    return new iRegI_R10Oper( );
  case IREGI_R12:
    return new iRegI_R12Oper( );
  case IREGI_R13:
    return new iRegI_R13Oper( );
  case IREGI_R14:
    return new iRegI_R14Oper( );
  case IREGL:
    return new iRegLOper( );
  case IREGLNOSP:
    return new iRegLNoSpOper( );
  case IREGL_R28:
    return new iRegL_R28Oper( );
  case IREGL_R29:
    return new iRegL_R29Oper( );
  case IREGL_R30:
    return new iRegL_R30Oper( );
  case IREGP:
    return new iRegPOper( );
  case IREGPNOSP:
    return new iRegPNoSpOper( );
  case IREGP_R10:
    return new iRegP_R10Oper( );
  case IREGP_R11:
    return new iRegP_R11Oper( );
  case IREGP_R12:
    return new iRegP_R12Oper( );
  case IREGP_R13:
    return new iRegP_R13Oper( );
  case IREGP_R14:
    return new iRegP_R14Oper( );
  case IREGP_R15:
    return new iRegP_R15Oper( );
  case IREGP_R16:
    return new iRegP_R16Oper( );
  case IREGP_R28:
    return new iRegP_R28Oper( );
  case IREGN:
    return new iRegNOper( );
  case IREGNNOSP:
    return new iRegNNoSpOper( );
  case IREGIHEAPBASE:
    return new iRegIHeapbaseOper( );
  case IREGL_R10:
    return new iRegL_R10Oper( );
  case FREGF:
    return new fRegFOper( );
  case FREGD:
    return new fRegDOper( );
  case VREG:
    return new vRegOper( );
  case VREG_V1:
    return new vReg_V1Oper( );
  case VREG_V2:
    return new vReg_V2Oper( );
  case VREG_V3:
    return new vReg_V3Oper( );
  case VREG_V4:
    return new vReg_V4Oper( );
  case VREG_V5:
    return new vReg_V5Oper( );
  case JAVATHREAD_REGP:
    return new javaThread_RegPOper( );
  case INDIRECT:
    return new indirectOper( );
  case INDOFFI:
    return new indOffIOper(_kids[1]->_leaf->get_int() );
  case INDOFFL:
    return new indOffLOper(_kids[1]->_leaf->get_long() );
  case INDIRECTN:
    return new indirectNOper( );
  case INDOFFIN:
    return new indOffINOper(_kids[1]->_leaf->get_int() );
  case INDOFFLN:
    return new indOffLNOper(_kids[1]->_leaf->get_long() );
  case THREAD_ANCHOR_PC:
    return new thread_anchor_pcOper(_kids[1]->_leaf->get_long() );
  case STACKSLOTI:
    return new stackSlotIOper( );
  case STACKSLOTF:
    return new stackSlotFOper( );
  case STACKSLOTD:
    return new stackSlotDOper( );
  case STACKSLOTL:
    return new stackSlotLOper( );
  case IREGL2I:
    return new iRegL2IOper( );
  case CMPOP:
    return new cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new cmpOpUOper(_leaf->as_Bool()->_test._test );
  case CMPOPEQNE:
    return new cmpOpEqNeOper(_leaf->as_Bool()->_test._test );
  case CMPOPULTGE:
    return new cmpOpULtGeOper(_leaf->as_Bool()->_test._test );
  case CMPOPUEQNELEGT:
    return new cmpOpUEqNeLeGtOper(_leaf->as_Bool()->_test._test );
  case RFLAGSREG:
    return new rFlagsRegOper( );
  case INLINE_CACHE_REGP:
    return new inline_cache_RegPOper( );
  case _DECODEN_IREGN_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  case _BINARY_IREGP_IREGP:    return NULL;
  case _BINARY_IREGL_IREGL:    return NULL;
  case _BINARY_IREGI_IREGI:    return NULL;
  case _BINARY_IREGI_R12_IREGI_R13:    return NULL;
  case _BINARY_IREGN_IREGN:    return NULL;
  case _CONVL2I_IREGL_:    return NULL;
  case _CONVI2L_IREGI_:    return NULL;
  case _RSHIFTI_IREGIORL2I_IMMI_31:    return NULL;
  case _RSHIFTL_IREGL_IMMI_63:    return NULL;
  case _CASTP2X_IREGP_:    return NULL;
  case _BINARY_FREGF_FREGF:    return NULL;
  case _BINARY_FREGD_FREGD:    return NULL;
  case _NEGF_FREGF_:    return NULL;
  case _NEGD_FREGD_:    return NULL;
  case _BINARY__NEGF_FREGF__FREGF:    return NULL;
  case _BINARY_FREGF__NEGF_FREGF_:    return NULL;
  case _BINARY__NEGD_FREGD__FREGD:    return NULL;
  case _BINARY_FREGD__NEGD_FREGD_:    return NULL;
  case _CONVI2L_IREGIORL2I_:    return NULL;
  case _CASTP2X__DECODEN_IREGN__:    return NULL;
  case _CMPI_IREGI_IREGI:    return NULL;
  case _CMPU_IREGI_IREGI:    return NULL;
  case _CMPL_IREGL_IREGL:    return NULL;
  case _CMPUL_IREGL_IREGL:    return NULL;
  case _CMPP_IREGP_IREGP:    return NULL;
  case _CMPN_IREGN_IREGN:    return NULL;
  case _CMPF_FREGF_FREGF:    return NULL;
  case _CMPD_FREGD_FREGD:    return NULL;
  case _CMPI_IREGI_IMMI0:    return NULL;
  case _CMPU_IREGI_IMMI0:    return NULL;
  case _CMPL_IREGL_IMML0:    return NULL;
  case _CMPUL_IREGL_IMML0:    return NULL;
  case _CMPP_IREGP_IMMP0:    return NULL;
  case _CMPN_IREGN_IMMN0:    return NULL;
  case _CMPP__DECODEN_IREGN__IMMP0:    return NULL;
  case _BINARY_CMPOP__CMPI_IREGI_IREGI:    return NULL;
  case _BINARY_IREGINOSP_IREGI:    return NULL;
  case _BINARY_CMPOPU__CMPU_IREGI_IREGI:    return NULL;
  case _BINARY_CMPOP__CMPL_IREGL_IREGL:    return NULL;
  case _BINARY_CMPOPU__CMPUL_IREGL_IREGL:    return NULL;
  case _BINARY_IREGLNOSP_IREGL:    return NULL;
  case _PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10:    return NULL;
  case _BINARY_IREGP_R11_IREGI_R12:    return NULL;
  case _BINARY_IREGP_R13_IREGI_R14:    return NULL;
  case _BINARY_IREGP_R13_IMMI_LE_4:    return NULL;
  case _BINARY_IREGP_R13_IMMI_1:    return NULL;
  case _BINARY_IREGP_R11_IREGP_R13:    return NULL;
  case _BINARY_VREG_VREG:    return NULL;
  case _NEGVF_VREG_:    return NULL;
  case _BINARY__NEGVF_VREG__VREG:    return NULL;
  case _BINARY_VREG__NEGVF_VREG_:    return NULL;
  case _NEGVD_VREG_:    return NULL;
  case _BINARY__NEGVD_VREG__VREG:    return NULL;
  case _BINARY_VREG__NEGVD_VREG_:    return NULL;
  case _MULVB_VREG_VREG:    return NULL;
  case _MULVS_VREG_VREG:    return NULL;
  case _MULVI_VREG_VREG:    return NULL;
  case _MULVL_VREG_VREG:    return NULL;
  case _RSHIFTCNTV_IMMI_:    return NULL;
  case _LSHIFTCNTV_IMMI_:    return NULL;
  case _BINARY_IREGP_R11_IREGI_R13:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_24:    return NULL;
  case _LSHIFTI_IREGIORL2I_IMMI_16:    return NULL;
  case _LSHIFTL_IREGL_IMMISCALE:    return NULL;
  case _LSHIFTL__CONVI2L_IREGI__IMMISCALE:    return NULL;
  case _XORI_IREGI_IMMI_M1:    return NULL;
  case _XORL_IREGL_IMML_M1:    return NULL;
  case _ANDI_IREGIORL2I_IMMIPOWEROF2:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode){
  switch(opcode) {
  case loadB_rule: {
      loadBNode *node = new loadBNode();
      return node;
    }
  case loadB2L_rule: {
      loadB2LNode *node = new loadB2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new loadUBNode();
      return node;
    }
  case loadUB2L_rule: {
      loadUB2LNode *node = new loadUB2LNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new loadSNode();
      return node;
    }
  case loadS2L_rule: {
      loadS2LNode *node = new loadS2LNode();
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new loadUSNode();
      return node;
    }
  case loadUS2L_rule: {
      loadUS2LNode *node = new loadUS2LNode();
      return node;
    }
  case loadI_rule: {
      loadINode *node = new loadINode();
      return node;
    }
  case loadI2L_rule: {
      loadI2LNode *node = new loadI2LNode();
      return node;
    }
  case loadUI2L_rule: {
      loadUI2LNode *node = new loadUI2LNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new loadLNode();
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new loadRangeNode();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new loadFNode();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new loadDNode();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new loadConINode();
      node->_opnd_array[1] = new immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL_rule: {
      loadConLNode *node = new loadConLNode();
      node->_opnd_array[1] = new immLOper(_leaf->get_long() );
      return node;
    }
  case loadConP_rule: {
      loadConPNode *node = new loadConPNode();
      node->_opnd_array[1] = new immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP0_rule: {
      loadConP0Node *node = new loadConP0Node();
      node->_opnd_array[1] = new immP0Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP1_rule: {
      loadConP1Node *node = new loadConP1Node();
      node->_opnd_array[1] = new immP_1Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadByteMapBase_rule: {
      loadByteMapBaseNode *node = new loadByteMapBaseNode();
      node->_opnd_array[1] = new immByteMapBaseOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConN_rule: {
      loadConNNode *node = new loadConNNode();
      node->_opnd_array[1] = new immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN0_rule: {
      loadConN0Node *node = new loadConN0Node();
      node->_opnd_array[1] = new immN0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_rule: {
      loadConNKlassNode *node = new loadConNKlassNode();
      node->_opnd_array[1] = new immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new loadConFNode();
      node->_opnd_array[1] = new immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF0_rule: {
      loadConF0Node *node = new loadConF0Node();
      node->_opnd_array[1] = new immF0Oper(_leaf->getf() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new loadConDNode();
      node->_opnd_array[1] = new immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD0_rule: {
      loadConD0Node *node = new loadConD0Node();
      node->_opnd_array[1] = new immD0Oper(_leaf->getd() );
      return node;
    }
  case storeimmCM0_rule: {
      storeimmCM0Node *node = new storeimmCM0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmCM0_ordered_rule: {
      storeimmCM0_orderedNode *node = new storeimmCM0_orderedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmB0_rule: {
      storeimmB0Node *node = new storeimmB0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmC0_rule: {
      storeimmC0Node *node = new storeimmC0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmI0_rule: {
      storeimmI0Node *node = new storeimmI0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_rule: {
      storeLNode *node = new storeLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmL0_rule: {
      storeimmL0Node *node = new storeimmL0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeimmP0_rule: {
      storeimmP0Node *node = new storeimmP0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN0_rule: {
      storeImmN0Node *node = new storeImmN0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_rule: {
      storeFNode *node = new storeFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_rule: {
      storeDNode *node = new storeDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new storePConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new storeLConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new storeIConditionalNode();
      return node;
    }
  case compareAndSwapB_rule: {
      compareAndSwapBNode *node = new compareAndSwapBNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndSwapS_rule: {
      compareAndSwapSNode *node = new compareAndSwapSNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new compareAndSwapINode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new compareAndSwapPNode();
      return node;
    }
  case compareAndSwapN_rule: {
      compareAndSwapNNode *node = new compareAndSwapNNode();
      return node;
    }
  case compareAndSwapBAcq_rule: {
      compareAndSwapBAcqNode *node = new compareAndSwapBAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndSwapSAcq_rule: {
      compareAndSwapSAcqNode *node = new compareAndSwapSAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndSwapIAcq_rule: {
      compareAndSwapIAcqNode *node = new compareAndSwapIAcqNode();
      return node;
    }
  case compareAndSwapLAcq_rule: {
      compareAndSwapLAcqNode *node = new compareAndSwapLAcqNode();
      return node;
    }
  case compareAndSwapPAcq_rule: {
      compareAndSwapPAcqNode *node = new compareAndSwapPAcqNode();
      return node;
    }
  case compareAndSwapNAcq_rule: {
      compareAndSwapNAcqNode *node = new compareAndSwapNAcqNode();
      return node;
    }
  case compareAndExchangeB_rule: {
      compareAndExchangeBNode *node = new compareAndExchangeBNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeS_rule: {
      compareAndExchangeSNode *node = new compareAndExchangeSNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeI_rule: {
      compareAndExchangeINode *node = new compareAndExchangeINode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeL_rule: {
      compareAndExchangeLNode *node = new compareAndExchangeLNode();
      node->set_opnd_array(4, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case compareAndExchangeN_rule: {
      compareAndExchangeNNode *node = new compareAndExchangeNNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeP_rule: {
      compareAndExchangePNode *node = new compareAndExchangePNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeBAcq_rule: {
      compareAndExchangeBAcqNode *node = new compareAndExchangeBAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeSAcq_rule: {
      compareAndExchangeSAcqNode *node = new compareAndExchangeSAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeIAcq_rule: {
      compareAndExchangeIAcqNode *node = new compareAndExchangeIAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case compareAndExchangeLAcq_rule: {
      compareAndExchangeLAcqNode *node = new compareAndExchangeLAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case compareAndExchangeNAcq_rule: {
      compareAndExchangeNAcqNode *node = new compareAndExchangeNAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangePAcq_rule: {
      compareAndExchangePAcqNode *node = new compareAndExchangePAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapB_rule: {
      weakCompareAndSwapBNode *node = new weakCompareAndSwapBNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case weakCompareAndSwapS_rule: {
      weakCompareAndSwapSNode *node = new weakCompareAndSwapSNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case weakCompareAndSwapI_rule: {
      weakCompareAndSwapINode *node = new weakCompareAndSwapINode();
      return node;
    }
  case weakCompareAndSwapL_rule: {
      weakCompareAndSwapLNode *node = new weakCompareAndSwapLNode();
      return node;
    }
  case weakCompareAndSwapN_rule: {
      weakCompareAndSwapNNode *node = new weakCompareAndSwapNNode();
      return node;
    }
  case weakCompareAndSwapP_rule: {
      weakCompareAndSwapPNode *node = new weakCompareAndSwapPNode();
      return node;
    }
  case weakCompareAndSwapBAcq_rule: {
      weakCompareAndSwapBAcqNode *node = new weakCompareAndSwapBAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case weakCompareAndSwapSAcq_rule: {
      weakCompareAndSwapSAcqNode *node = new weakCompareAndSwapSAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      return node;
    }
  case weakCompareAndSwapIAcq_rule: {
      weakCompareAndSwapIAcqNode *node = new weakCompareAndSwapIAcqNode();
      return node;
    }
  case weakCompareAndSwapLAcq_rule: {
      weakCompareAndSwapLAcqNode *node = new weakCompareAndSwapLAcqNode();
      return node;
    }
  case weakCompareAndSwapNAcq_rule: {
      weakCompareAndSwapNAcqNode *node = new weakCompareAndSwapNAcqNode();
      return node;
    }
  case weakCompareAndSwapPAcq_rule: {
      weakCompareAndSwapPAcqNode *node = new weakCompareAndSwapPAcqNode();
      return node;
    }
  case get_and_setI_rule: {
      get_and_setINode *node = new get_and_setINode();
      return node;
    }
  case get_and_setL_rule: {
      get_and_setLNode *node = new get_and_setLNode();
      return node;
    }
  case get_and_setN_rule: {
      get_and_setNNode *node = new get_and_setNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setP_rule: {
      get_and_setPNode *node = new get_and_setPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setIAcq_rule: {
      get_and_setIAcqNode *node = new get_and_setIAcqNode();
      return node;
    }
  case get_and_setLAcq_rule: {
      get_and_setLAcqNode *node = new get_and_setLAcqNode();
      return node;
    }
  case get_and_setNAcq_rule: {
      get_and_setNAcqNode *node = new get_and_setNAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_setPAcq_rule: {
      get_and_setPAcqNode *node = new get_and_setPAcqNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case get_and_addL_rule: {
      get_and_addLNode *node = new get_and_addLNode();
      return node;
    }
  case get_and_addL_no_res_rule: {
      get_and_addL_no_resNode *node = new get_and_addL_no_resNode();
      return node;
    }
  case get_and_addLi_rule: {
      get_and_addLiNode *node = new get_and_addLiNode();
      return node;
    }
  case get_and_addLi_no_res_rule: {
      get_and_addLi_no_resNode *node = new get_and_addLi_no_resNode();
      return node;
    }
  case get_and_addI_rule: {
      get_and_addINode *node = new get_and_addINode();
      return node;
    }
  case get_and_addI_no_res_rule: {
      get_and_addI_no_resNode *node = new get_and_addI_no_resNode();
      return node;
    }
  case get_and_addIi_rule: {
      get_and_addIiNode *node = new get_and_addIiNode();
      return node;
    }
  case get_and_addIi_no_res_rule: {
      get_and_addIi_no_resNode *node = new get_and_addIi_no_resNode();
      return node;
    }
  case get_and_addLAcq_rule: {
      get_and_addLAcqNode *node = new get_and_addLAcqNode();
      return node;
    }
  case get_and_addL_no_resAcq_rule: {
      get_and_addL_no_resAcqNode *node = new get_and_addL_no_resAcqNode();
      return node;
    }
  case get_and_addLiAcq_rule: {
      get_and_addLiAcqNode *node = new get_and_addLiAcqNode();
      return node;
    }
  case get_and_addLi_no_resAcq_rule: {
      get_and_addLi_no_resAcqNode *node = new get_and_addLi_no_resAcqNode();
      return node;
    }
  case get_and_addIAcq_rule: {
      get_and_addIAcqNode *node = new get_and_addIAcqNode();
      return node;
    }
  case get_and_addI_no_resAcq_rule: {
      get_and_addI_no_resAcqNode *node = new get_and_addI_no_resAcqNode();
      return node;
    }
  case get_and_addIiAcq_rule: {
      get_and_addIiAcqNode *node = new get_and_addIiAcqNode();
      return node;
    }
  case get_and_addIi_no_resAcq_rule: {
      get_and_addIi_no_resAcqNode *node = new get_and_addIi_no_resAcqNode();
      return node;
    }
  case addI_reg_reg_rule: {
      addI_reg_regNode *node = new addI_reg_regNode();
      return node;
    }
  case addI_reg_imm_rule: {
      addI_reg_immNode *node = new addI_reg_immNode();
      return node;
    }
  case addI_reg_imm_l2i_rule: {
      addI_reg_imm_l2iNode *node = new addI_reg_imm_l2iNode();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case lShiftL_regI_immGE32_rule: {
      lShiftL_regI_immGE32Node *node = new lShiftL_regI_immGE32Node();
      return node;
    }
  case addP_reg_imm_rule: {
      addP_reg_immNode *node = new addP_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addL_reg_reg_rule: {
      addL_reg_regNode *node = new addL_reg_regNode();
      return node;
    }
  case addL_reg_imm_rule: {
      addL_reg_immNode *node = new addL_reg_immNode();
      return node;
    }
  case subI_reg_reg_rule: {
      subI_reg_regNode *node = new subI_reg_regNode();
      return node;
    }
  case subI_reg_imm_rule: {
      subI_reg_immNode *node = new subI_reg_immNode();
      return node;
    }
  case subL_reg_reg_rule: {
      subL_reg_regNode *node = new subL_reg_regNode();
      return node;
    }
  case subL_reg_imm_rule: {
      subL_reg_immNode *node = new subL_reg_immNode();
      return node;
    }
  case negI_reg_rule: {
      negI_regNode *node = new negI_regNode();
      return node;
    }
  case negL_reg_rule: {
      negL_regNode *node = new negL_regNode();
      return node;
    }
  case mulI_rule: {
      mulINode *node = new mulINode();
      return node;
    }
  case mulL_rule: {
      mulLNode *node = new mulLNode();
      return node;
    }
  case mulHiL_rReg_rule: {
      mulHiL_rRegNode *node = new mulHiL_rRegNode();
      return node;
    }
  case divI_rule: {
      divINode *node = new divINode();
      return node;
    }
  case signExtract_rule: {
      signExtractNode *node = new signExtractNode();
      return node;
    }
  case divL_rule: {
      divLNode *node = new divLNode();
      return node;
    }
  case signExtractL_rule: {
      signExtractLNode *node = new signExtractLNode();
      return node;
    }
  case modI_rule: {
      modINode *node = new modINode();
      return node;
    }
  case modL_rule: {
      modLNode *node = new modLNode();
      return node;
    }
  case lShiftI_reg_reg_rule: {
      lShiftI_reg_regNode *node = new lShiftI_reg_regNode();
      return node;
    }
  case lShiftI_reg_imm_rule: {
      lShiftI_reg_immNode *node = new lShiftI_reg_immNode();
      return node;
    }
  case urShiftI_reg_reg_rule: {
      urShiftI_reg_regNode *node = new urShiftI_reg_regNode();
      return node;
    }
  case urShiftI_reg_imm_rule: {
      urShiftI_reg_immNode *node = new urShiftI_reg_immNode();
      return node;
    }
  case rShiftI_reg_reg_rule: {
      rShiftI_reg_regNode *node = new rShiftI_reg_regNode();
      return node;
    }
  case rShiftI_reg_imm_rule: {
      rShiftI_reg_immNode *node = new rShiftI_reg_immNode();
      return node;
    }
  case lShiftL_reg_reg_rule: {
      lShiftL_reg_regNode *node = new lShiftL_reg_regNode();
      return node;
    }
  case lShiftL_reg_imm_rule: {
      lShiftL_reg_immNode *node = new lShiftL_reg_immNode();
      return node;
    }
  case urShiftL_reg_reg_rule: {
      urShiftL_reg_regNode *node = new urShiftL_reg_regNode();
      return node;
    }
  case urShiftL_reg_imm_rule: {
      urShiftL_reg_immNode *node = new urShiftL_reg_immNode();
      return node;
    }
  case urShiftP_reg_imm_rule: {
      urShiftP_reg_immNode *node = new urShiftP_reg_immNode();
      return node;
    }
  case rShiftL_reg_reg_rule: {
      rShiftL_reg_regNode *node = new rShiftL_reg_regNode();
      return node;
    }
  case rShiftL_reg_imm_rule: {
      rShiftL_reg_immNode *node = new rShiftL_reg_immNode();
      return node;
    }
  case regI_not_reg_rule: {
      regI_not_regNode *node = new regI_not_regNode();
      return node;
    }
  case regL_not_reg_rule: {
      regL_not_regNode *node = new regL_not_regNode();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new addF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new addD_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new subF_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new subD_reg_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new mulF_reg_regNode();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new mulD_reg_regNode();
      return node;
    }
  case maddF_reg_reg_rule: {
      maddF_reg_regNode *node = new maddF_reg_regNode();
      return node;
    }
  case maddD_reg_reg_rule: {
      maddD_reg_regNode *node = new maddD_reg_regNode();
      return node;
    }
  case msubF_reg_reg_rule: {
      msubF_reg_regNode *node = new msubF_reg_regNode();
      return node;
    }
  case msubD_reg_reg_rule: {
      msubD_reg_regNode *node = new msubD_reg_regNode();
      return node;
    }
  case nmsubF_reg_reg_rule: {
      nmsubF_reg_regNode *node = new nmsubF_reg_regNode();
      return node;
    }
  case nmsubF_reg_reg_0_rule: {
      nmsubF_reg_reg_0Node *node = new nmsubF_reg_reg_0Node();
      return node;
    }
  case nmsubD_reg_reg_rule: {
      nmsubD_reg_regNode *node = new nmsubD_reg_regNode();
      return node;
    }
  case nmsubD_reg_reg_0_rule: {
      nmsubD_reg_reg_0Node *node = new nmsubD_reg_reg_0Node();
      return node;
    }
  case nmaddF_reg_reg_rule: {
      nmaddF_reg_regNode *node = new nmaddF_reg_regNode();
      return node;
    }
  case nmaddF_reg_reg_0_rule: {
      nmaddF_reg_reg_0Node *node = new nmaddF_reg_reg_0Node();
      return node;
    }
  case nmaddD_reg_reg_rule: {
      nmaddD_reg_regNode *node = new nmaddD_reg_regNode();
      return node;
    }
  case nmaddD_reg_reg_0_rule: {
      nmaddD_reg_reg_0Node *node = new nmaddD_reg_reg_0Node();
      return node;
    }
  case maxF_reg_reg_rule: {
      maxF_reg_regNode *node = new maxF_reg_regNode();
      node->set_opnd_array(3, MachOperGenerator(FREGF));
      return node;
    }
  case minF_reg_reg_rule: {
      minF_reg_regNode *node = new minF_reg_regNode();
      node->set_opnd_array(3, MachOperGenerator(FREGF));
      return node;
    }
  case maxD_reg_reg_rule: {
      maxD_reg_regNode *node = new maxD_reg_regNode();
      node->set_opnd_array(3, MachOperGenerator(FREGD));
      return node;
    }
  case minD_reg_reg_rule: {
      minD_reg_regNode *node = new minD_reg_regNode();
      node->set_opnd_array(3, MachOperGenerator(FREGD));
      return node;
    }
  case divF_reg_reg_rule: {
      divF_reg_regNode *node = new divF_reg_regNode();
      return node;
    }
  case divD_reg_reg_rule: {
      divD_reg_regNode *node = new divD_reg_regNode();
      return node;
    }
  case negF_reg_reg_rule: {
      negF_reg_regNode *node = new negF_reg_regNode();
      return node;
    }
  case negD_reg_reg_rule: {
      negD_reg_regNode *node = new negD_reg_regNode();
      return node;
    }
  case absI_reg_rule: {
      absI_regNode *node = new absI_regNode();
      return node;
    }
  case absL_reg_rule: {
      absL_regNode *node = new absL_regNode();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new absD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new sqrtF_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new sqrtD_regNode();
      return node;
    }
  case andI_reg_reg_rule: {
      andI_reg_regNode *node = new andI_reg_regNode();
      return node;
    }
  case andI_reg_imm_rule: {
      andI_reg_immNode *node = new andI_reg_immNode();
      return node;
    }
  case orI_reg_reg_rule: {
      orI_reg_regNode *node = new orI_reg_regNode();
      return node;
    }
  case orI_reg_imm_rule: {
      orI_reg_immNode *node = new orI_reg_immNode();
      return node;
    }
  case xorI_reg_reg_rule: {
      xorI_reg_regNode *node = new xorI_reg_regNode();
      return node;
    }
  case xorI_reg_imm_rule: {
      xorI_reg_immNode *node = new xorI_reg_immNode();
      return node;
    }
  case andL_reg_reg_rule: {
      andL_reg_regNode *node = new andL_reg_regNode();
      return node;
    }
  case andL_reg_imm_rule: {
      andL_reg_immNode *node = new andL_reg_immNode();
      return node;
    }
  case orL_reg_reg_rule: {
      orL_reg_regNode *node = new orL_reg_regNode();
      return node;
    }
  case orL_reg_imm_rule: {
      orL_reg_immNode *node = new orL_reg_immNode();
      return node;
    }
  case xorL_reg_reg_rule: {
      xorL_reg_regNode *node = new xorL_reg_regNode();
      return node;
    }
  case xorL_reg_imm_rule: {
      xorL_reg_immNode *node = new xorL_reg_immNode();
      return node;
    }
  case bytes_reverse_int_rule: {
      bytes_reverse_intNode *node = new bytes_reverse_intNode();
      return node;
    }
  case bytes_reverse_long_rule: {
      bytes_reverse_longNode *node = new bytes_reverse_longNode();
      return node;
    }
  case bytes_reverse_unsigned_short_rule: {
      bytes_reverse_unsigned_shortNode *node = new bytes_reverse_unsigned_shortNode();
      return node;
    }
  case bytes_reverse_short_rule: {
      bytes_reverse_shortNode *node = new bytes_reverse_shortNode();
      return node;
    }
  case load_fence_rule: {
      load_fenceNode *node = new load_fenceNode();
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new membar_acquireNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new membar_acquire_lockNode();
      return node;
    }
  case store_fence_rule: {
      store_fenceNode *node = new store_fenceNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new membar_releaseNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new membar_storestoreNode();
      return node;
    }
  case membar_storestore_0_rule: {
      membar_storestore_0Node *node = new membar_storestore_0Node();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new membar_release_lockNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new membar_volatileNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new castP2XNode();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castLL_rule: {
      castLLNode *node = new castLLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new castIINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castFF_rule: {
      castFFNode *node = new castFFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castDD_rule: {
      castDDNode *node = new castDDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castVV_rule: {
      castVVNode *node = new castVVNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case convI2Bool_rule: {
      convI2BoolNode *node = new convI2BoolNode();
      return node;
    }
  case convP2Bool_rule: {
      convP2BoolNode *node = new convP2BoolNode();
      return node;
    }
  case convI2L_reg_reg_rule: {
      convI2L_reg_regNode *node = new convI2L_reg_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new convL2I_regNode();
      return node;
    }
  case convI2UL_reg_reg_rule: {
      convI2UL_reg_regNode *node = new convI2UL_reg_regNode();
      return node;
    }
  case convF2D_reg_rule: {
      convF2D_regNode *node = new convF2D_regNode();
      return node;
    }
  case convD2F_reg_rule: {
      convD2F_regNode *node = new convD2F_regNode();
      return node;
    }
  case convF2I_reg_reg_rule: {
      convF2I_reg_regNode *node = new convF2I_reg_regNode();
      return node;
    }
  case convI2F_reg_reg_rule: {
      convI2F_reg_regNode *node = new convI2F_reg_regNode();
      return node;
    }
  case convF2L_reg_reg_rule: {
      convF2L_reg_regNode *node = new convF2L_reg_regNode();
      return node;
    }
  case convL2F_reg_reg_rule: {
      convL2F_reg_regNode *node = new convL2F_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_rule: {
      convD2I_reg_regNode *node = new convD2I_reg_regNode();
      return node;
    }
  case convI2D_reg_reg_rule: {
      convI2D_reg_regNode *node = new convI2D_reg_regNode();
      return node;
    }
  case convD2L_reg_reg_rule: {
      convD2L_reg_regNode *node = new convD2L_reg_regNode();
      return node;
    }
  case convL2D_reg_reg_rule: {
      convL2D_reg_regNode *node = new convL2D_reg_regNode();
      return node;
    }
  case convP2I_rule: {
      convP2INode *node = new convP2INode();
      return node;
    }
  case convN2I_rule: {
      convN2INode *node = new convN2INode();
      return node;
    }
  case encodeHeapOop_rule: {
      encodeHeapOopNode *node = new encodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_rule: {
      decodeHeapOopNode *node = new decodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_not_null_rule: {
      decodeHeapOop_not_nullNode *node = new decodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeKlass_not_null_rule: {
      encodeKlass_not_nullNode *node = new encodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeKlass_not_null_rule: {
      decodeKlass_not_nullNode *node = new decodeKlass_not_nullNode();
      node->set_opnd_array(2, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case MoveF2I_stack_reg_rule: {
      MoveF2I_stack_regNode *node = new MoveF2I_stack_regNode();
      return node;
    }
  case MoveI2F_stack_reg_rule: {
      MoveI2F_stack_regNode *node = new MoveI2F_stack_regNode();
      return node;
    }
  case MoveD2L_stack_reg_rule: {
      MoveD2L_stack_regNode *node = new MoveD2L_stack_regNode();
      return node;
    }
  case MoveL2D_stack_reg_rule: {
      MoveL2D_stack_regNode *node = new MoveL2D_stack_regNode();
      return node;
    }
  case MoveF2I_reg_stack_rule: {
      MoveF2I_reg_stackNode *node = new MoveF2I_reg_stackNode();
      return node;
    }
  case MoveI2F_reg_stack_rule: {
      MoveI2F_reg_stackNode *node = new MoveI2F_reg_stackNode();
      return node;
    }
  case MoveD2L_reg_stack_rule: {
      MoveD2L_reg_stackNode *node = new MoveD2L_reg_stackNode();
      return node;
    }
  case MoveL2D_reg_stack_rule: {
      MoveL2D_reg_stackNode *node = new MoveL2D_reg_stackNode();
      return node;
    }
  case MoveF2I_reg_reg_rule: {
      MoveF2I_reg_regNode *node = new MoveF2I_reg_regNode();
      return node;
    }
  case MoveI2F_reg_reg_rule: {
      MoveI2F_reg_regNode *node = new MoveI2F_reg_regNode();
      return node;
    }
  case MoveD2L_reg_reg_rule: {
      MoveD2L_reg_regNode *node = new MoveD2L_reg_regNode();
      return node;
    }
  case MoveL2D_reg_reg_rule: {
      MoveL2D_reg_regNode *node = new MoveL2D_reg_regNode();
      return node;
    }
  case cmpF3_reg_reg_rule: {
      cmpF3_reg_regNode *node = new cmpF3_reg_regNode();
      return node;
    }
  case cmpD3_reg_reg_rule: {
      cmpD3_reg_regNode *node = new cmpD3_reg_regNode();
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new cmpL3_reg_regNode();
      return node;
    }
  case cmpLTMask_reg_reg_rule: {
      cmpLTMask_reg_regNode *node = new cmpLTMask_reg_regNode();
      return node;
    }
  case cmpLTMask_reg_zero_rule: {
      cmpLTMask_reg_zeroNode *node = new cmpLTMask_reg_zeroNode();
      return node;
    }
  case minI_reg_reg_rule: {
      minI_reg_regNode *node = new minI_reg_regNode();
      return node;
    }
  case maxI_reg_reg_rule: {
      maxI_reg_regNode *node = new maxI_reg_regNode();
      return node;
    }
  case minI_reg_zero_rule: {
      minI_reg_zeroNode *node = new minI_reg_zeroNode();
      return node;
    }
  case minI_reg_zero_0_rule: {
      minI_reg_zero_0Node *node = new minI_reg_zero_0Node();
      return node;
    }
  case maxI_reg_zero_rule: {
      maxI_reg_zeroNode *node = new maxI_reg_zeroNode();
      return node;
    }
  case maxI_reg_zero_0_rule: {
      maxI_reg_zero_0Node *node = new maxI_reg_zero_0Node();
      return node;
    }
  case minI_rReg_rule: {
      minI_rRegNode *node = new minI_rRegNode();
      return node;
    }
  case maxI_rReg_rule: {
      maxI_rRegNode *node = new maxI_rRegNode();
      return node;
    }
  case branch_rule: {
      branchNode *node = new branchNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL));
      return node;
    }
  case cmpFlag_branch_rule: {
      cmpFlag_branchNode *node = new cmpFlag_branchNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_branch_rule: {
      cmpI_branchNode *node = new cmpI_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_loop_rule: {
      cmpI_loopNode *node = new cmpI_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpU_branch_rule: {
      cmpU_branchNode *node = new cmpU_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpU_loop_rule: {
      cmpU_loopNode *node = new cmpU_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_branch_rule: {
      cmpL_branchNode *node = new cmpL_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_loop_rule: {
      cmpL_loopNode *node = new cmpL_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_branch_rule: {
      cmpUL_branchNode *node = new cmpUL_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUL_loop_rule: {
      cmpUL_loopNode *node = new cmpUL_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_branch_rule: {
      cmpP_branchNode *node = new cmpP_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_loop_rule: {
      cmpP_loopNode *node = new cmpP_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_branch_rule: {
      cmpN_branchNode *node = new cmpN_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_loop_rule: {
      cmpN_loopNode *node = new cmpN_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpF_branch_rule: {
      cmpF_branchNode *node = new cmpF_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpF_loop_rule: {
      cmpF_loopNode *node = new cmpF_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpD_branch_rule: {
      cmpD_branchNode *node = new cmpD_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpD_loop_rule: {
      cmpD_loopNode *node = new cmpD_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_reg_imm0_branch_rule: {
      cmpI_reg_imm0_branchNode *node = new cmpI_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpI_reg_imm0_loop_rule: {
      cmpI_reg_imm0_loopNode *node = new cmpI_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUEqNeLeGt_reg_imm0_branch_rule: {
      cmpUEqNeLeGt_reg_imm0_branchNode *node = new cmpUEqNeLeGt_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpUEqNeLeGt_reg_imm0_loop_rule: {
      cmpUEqNeLeGt_reg_imm0_loopNode *node = new cmpUEqNeLeGt_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_reg_imm0_branch_rule: {
      cmpL_reg_imm0_branchNode *node = new cmpL_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpL_reg_imm0_loop_rule: {
      cmpL_reg_imm0_loopNode *node = new cmpL_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpULEqNeLeGt_reg_imm0_branch_rule: {
      cmpULEqNeLeGt_reg_imm0_branchNode *node = new cmpULEqNeLeGt_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpULEqNeLeGt_reg_imm0_loop_rule: {
      cmpULEqNeLeGt_reg_imm0_loopNode *node = new cmpULEqNeLeGt_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_imm0_branch_rule: {
      cmpP_imm0_branchNode *node = new cmpP_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_imm0_loop_rule: {
      cmpP_imm0_loopNode *node = new cmpP_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_imm0_branch_rule: {
      cmpN_imm0_branchNode *node = new cmpN_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_imm0_loop_rule: {
      cmpN_imm0_loopNode *node = new cmpN_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_narrowOop_imm0_branch_rule: {
      cmpP_narrowOop_imm0_branchNode *node = new cmpP_narrowOop_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpP_narrowOop_imm0_loop_rule: {
      cmpP_narrowOop_imm0_loopNode *node = new cmpP_narrowOop_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpFlag_branch_rule: {
      far_cmpFlag_branchNode *node = new far_cmpFlag_branchNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_branch_rule: {
      far_cmpI_branchNode *node = new far_cmpI_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_loop_rule: {
      far_cmpI_loopNode *node = new far_cmpI_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpU_branch_rule: {
      far_cmpU_branchNode *node = new far_cmpU_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpU_loop_rule: {
      far_cmpU_loopNode *node = new far_cmpU_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_branch_rule: {
      far_cmpL_branchNode *node = new far_cmpL_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpLloop_rule: {
      far_cmpLloopNode *node = new far_cmpLloopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpUL_branch_rule: {
      far_cmpUL_branchNode *node = new far_cmpUL_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpUL_loop_rule: {
      far_cmpUL_loopNode *node = new far_cmpUL_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_branch_rule: {
      far_cmpP_branchNode *node = new far_cmpP_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_loop_rule: {
      far_cmpP_loopNode *node = new far_cmpP_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpN_branch_rule: {
      far_cmpN_branchNode *node = new far_cmpN_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpN_loop_rule: {
      far_cmpN_loopNode *node = new far_cmpN_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpF_branch_rule: {
      far_cmpF_branchNode *node = new far_cmpF_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpF_loop_rule: {
      far_cmpF_loopNode *node = new far_cmpF_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpD_branch_rule: {
      far_cmpD_branchNode *node = new far_cmpD_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpD_loop_rule: {
      far_cmpD_loopNode *node = new far_cmpD_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_reg_imm0_branch_rule: {
      far_cmpI_reg_imm0_branchNode *node = new far_cmpI_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpI_reg_imm0_loop_rule: {
      far_cmpI_reg_imm0_loopNode *node = new far_cmpI_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpUEqNeLeGt_imm0_branch_rule: {
      far_cmpUEqNeLeGt_imm0_branchNode *node = new far_cmpUEqNeLeGt_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpUEqNeLeGt_reg_imm0_loop_rule: {
      far_cmpUEqNeLeGt_reg_imm0_loopNode *node = new far_cmpUEqNeLeGt_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULtGe_reg_imm0_branch_rule: {
      far_cmpULtGe_reg_imm0_branchNode *node = new far_cmpULtGe_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULtGe_reg_imm0_loop_rule: {
      far_cmpULtGe_reg_imm0_loopNode *node = new far_cmpULtGe_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_reg_imm0_branch_rule: {
      far_cmpL_reg_imm0_branchNode *node = new far_cmpL_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpL_reg_imm0_loop_rule: {
      far_cmpL_reg_imm0_loopNode *node = new far_cmpL_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULEqNeLeGt_reg_imm0_branch_rule: {
      far_cmpULEqNeLeGt_reg_imm0_branchNode *node = new far_cmpULEqNeLeGt_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULEqNeLeGt_reg_imm0_loop_rule: {
      far_cmpULEqNeLeGt_reg_imm0_loopNode *node = new far_cmpULEqNeLeGt_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULLtGe_reg_imm0_branch_rule: {
      far_cmpULLtGe_reg_imm0_branchNode *node = new far_cmpULLtGe_reg_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpULLtGe_reg_imm0_loop_rule: {
      far_cmpULLtGe_reg_imm0_loopNode *node = new far_cmpULLtGe_reg_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_imm0_branch_rule: {
      far_cmpP_imm0_branchNode *node = new far_cmpP_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_imm0_loop_rule: {
      far_cmpP_imm0_loopNode *node = new far_cmpP_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpN_imm0_branch_rule: {
      far_cmpN_imm0_branchNode *node = new far_cmpN_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpN_imm0_loop_rule: {
      far_cmpN_imm0_loopNode *node = new far_cmpN_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_narrowOop_imm0_branch_rule: {
      far_cmpP_narrowOop_imm0_branchNode *node = new far_cmpP_narrowOop_imm0_branchNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case far_cmpP_narrowOop_imm0_loop_rule: {
      far_cmpP_narrowOop_imm0_loopNode *node = new far_cmpP_narrowOop_imm0_loopNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmovI_cmpI_rule: {
      cmovI_cmpINode *node = new cmovI_cmpINode();
      return node;
    }
  case cmovI_cmpU_rule: {
      cmovI_cmpUNode *node = new cmovI_cmpUNode();
      return node;
    }
  case cmovI_cmpL_rule: {
      cmovI_cmpLNode *node = new cmovI_cmpLNode();
      return node;
    }
  case cmovI_cmpUL_rule: {
      cmovI_cmpULNode *node = new cmovI_cmpULNode();
      return node;
    }
  case cmovL_cmpL_rule: {
      cmovL_cmpLNode *node = new cmovL_cmpLNode();
      return node;
    }
  case cmovL_cmpUL_rule: {
      cmovL_cmpULNode *node = new cmovL_cmpULNode();
      return node;
    }
  case cmovL_cmpI_rule: {
      cmovL_cmpINode *node = new cmovL_cmpINode();
      return node;
    }
  case cmovL_cmpU_rule: {
      cmovL_cmpUNode *node = new cmovL_cmpUNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD));
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new partialSubtypeCheckNode();
      return node;
    }
  case partialSubtypeCheckVsZero_rule: {
      partialSubtypeCheckVsZeroNode *node = new partialSubtypeCheckVsZeroNode();
      return node;
    }
  case string_compareU_rule: {
      string_compareUNode *node = new string_compareUNode();
      return node;
    }
  case string_compareL_rule: {
      string_compareLNode *node = new string_compareLNode();
      return node;
    }
  case string_compareUL_rule: {
      string_compareULNode *node = new string_compareULNode();
      return node;
    }
  case string_compareLU_rule: {
      string_compareLUNode *node = new string_compareLUNode();
      return node;
    }
  case string_indexofUU_rule: {
      string_indexofUUNode *node = new string_indexofUUNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexofLL_rule: {
      string_indexofLLNode *node = new string_indexofLLNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexofUL_rule: {
      string_indexofULNode *node = new string_indexofULNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(10, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(11, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexof_conUU_rule: {
      string_indexof_conUUNode *node = new string_indexof_conUUNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexof_conLL_rule: {
      string_indexof_conLLNode *node = new string_indexof_conLLNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      return node;
    }
  case string_indexof_conUL_rule: {
      string_indexof_conULNode *node = new string_indexof_conULNode();
      node->set_opnd_array(5, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(9, MachOperGenerator(IREGINOSP));
      return node;
    }
  case stringU_indexof_char_rule: {
      stringU_indexof_charNode *node = new stringU_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      return node;
    }
  case stringL_indexof_char_rule: {
      stringL_indexof_charNode *node = new stringL_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(8, MachOperGenerator(IREGINOSP));
      return node;
    }
  case clearArray_reg_reg_rule: {
      clearArray_reg_regNode *node = new clearArray_reg_regNode();
      return node;
    }
  case clearArray_imm_reg_rule: {
      clearArray_imm_regNode *node = new clearArray_imm_regNode();
      return node;
    }
  case string_equalsL_rule: {
      string_equalsLNode *node = new string_equalsLNode();
      return node;
    }
  case string_equalsU_rule: {
      string_equalsUNode *node = new string_equalsUNode();
      return node;
    }
  case array_equalsB_rule: {
      array_equalsBNode *node = new array_equalsBNode();
      node->set_opnd_array(3, MachOperGenerator(IREGP_R13));
      node->set_opnd_array(4, MachOperGenerator(IREGP_R14));
      node->set_opnd_array(5, MachOperGenerator(IREGP_R15));
      node->set_opnd_array(6, MachOperGenerator(IREGP_R16));
      return node;
    }
  case array_equalsC_rule: {
      array_equalsCNode *node = new array_equalsCNode();
      node->set_opnd_array(3, MachOperGenerator(IREGP_R13));
      node->set_opnd_array(4, MachOperGenerator(IREGP_R14));
      node->set_opnd_array(5, MachOperGenerator(IREGP_R15));
      node->set_opnd_array(6, MachOperGenerator(IREGP_R16));
      return node;
    }
  case safePoint_rule: {
      safePointNode *node = new safePointNode();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new tlsLoadPNode();
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new TailCalljmpIndNode();
      return node;
    }
  case TailjmpInd_rule: {
      TailjmpIndNode *node = new TailjmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new RethrowExceptionNode();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new RetNode();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new ShouldNotReachHereNode();
      node->_halt_reason = _leaf->as_Halt()->_halt_reason;
      node->_reachable   = _leaf->as_Halt()->_reachable;
      return node;
    }
  case loadV_rule: {
      loadVNode *node = new loadVNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV_rule: {
      storeVNode *node = new storeVNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsB_rule: {
      vabsBNode *node = new vabsBNode();
      node->set_opnd_array(2, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsS_rule: {
      vabsSNode *node = new vabsSNode();
      node->set_opnd_array(2, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsI_rule: {
      vabsINode *node = new vabsINode();
      node->set_opnd_array(2, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsL_rule: {
      vabsLNode *node = new vabsLNode();
      node->set_opnd_array(2, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsF_rule: {
      vabsFNode *node = new vabsFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vabsD_rule: {
      vabsDNode *node = new vabsDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddB_rule: {
      vaddBNode *node = new vaddBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddS_rule: {
      vaddSNode *node = new vaddSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddI_rule: {
      vaddINode *node = new vaddINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddL_rule: {
      vaddLNode *node = new vaddLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddF_rule: {
      vaddFNode *node = new vaddFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vaddD_rule: {
      vaddDNode *node = new vaddDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vand_rule: {
      vandNode *node = new vandNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vor_rule: {
      vorNode *node = new vorNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vxor_rule: {
      vxorNode *node = new vxorNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdivF_rule: {
      vdivFNode *node = new vdivFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vdivD_rule: {
      vdivDNode *node = new vdivDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmax_rule: {
      vmaxNode *node = new vmaxNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmin_rule: {
      vminNode *node = new vminNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmaxF_rule: {
      vmaxFNode *node = new vmaxFNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmaxD_rule: {
      vmaxDNode *node = new vmaxDNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vminF_rule: {
      vminFNode *node = new vminFNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vminD_rule: {
      vminDNode *node = new vminDNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlaF_rule: {
      vfmlaFNode *node = new vfmlaFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlaD_rule: {
      vfmlaDNode *node = new vfmlaDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlsF_rule: {
      vfmlsFNode *node = new vfmlsFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlsF_0_rule: {
      vfmlsF_0Node *node = new vfmlsF_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlsD_rule: {
      vfmlsDNode *node = new vfmlsDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfmlsD_0_rule: {
      vfmlsD_0Node *node = new vfmlsD_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlaF_rule: {
      vfnmlaFNode *node = new vfnmlaFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlaF_0_rule: {
      vfnmlaF_0Node *node = new vfnmlaF_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlaD_rule: {
      vfnmlaDNode *node = new vfnmlaDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlaD_0_rule: {
      vfnmlaD_0Node *node = new vfnmlaD_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlsF_rule: {
      vfnmlsFNode *node = new vfnmlsFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vfnmlsD_rule: {
      vfnmlsDNode *node = new vfnmlsDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaB_rule: {
      vmlaBNode *node = new vmlaBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaB_0_rule: {
      vmlaB_0Node *node = new vmlaB_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaS_rule: {
      vmlaSNode *node = new vmlaSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaS_0_rule: {
      vmlaS_0Node *node = new vmlaS_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaI_rule: {
      vmlaINode *node = new vmlaINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaI_0_rule: {
      vmlaI_0Node *node = new vmlaI_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaL_rule: {
      vmlaLNode *node = new vmlaLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlaL_0_rule: {
      vmlaL_0Node *node = new vmlaL_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlsB_rule: {
      vmlsBNode *node = new vmlsBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlsS_rule: {
      vmlsSNode *node = new vmlsSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlsI_rule: {
      vmlsINode *node = new vmlsINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmlsL_rule: {
      vmlsLNode *node = new vmlsLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulB_rule: {
      vmulBNode *node = new vmulBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulS_rule: {
      vmulSNode *node = new vmulSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulI_rule: {
      vmulINode *node = new vmulINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulL_rule: {
      vmulLNode *node = new vmulLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulF_rule: {
      vmulFNode *node = new vmulFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmulD_rule: {
      vmulDNode *node = new vmulDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vnegF_rule: {
      vnegFNode *node = new vnegFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vnegD_rule: {
      vnegDNode *node = new vnegDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addB_rule: {
      reduce_addBNode *node = new reduce_addBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addS_rule: {
      reduce_addSNode *node = new reduce_addSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addI_rule: {
      reduce_addINode *node = new reduce_addINode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addL_rule: {
      reduce_addLNode *node = new reduce_addLNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addF_rule: {
      reduce_addFNode *node = new reduce_addFNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case reduce_addD_rule: {
      reduce_addDNode *node = new reduce_addDNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxB_rule: {
      vreduce_maxBNode *node = new vreduce_maxBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxS_rule: {
      vreduce_maxSNode *node = new vreduce_maxSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxI_rule: {
      vreduce_maxINode *node = new vreduce_maxINode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxL_rule: {
      vreduce_maxLNode *node = new vreduce_maxLNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minB_rule: {
      vreduce_minBNode *node = new vreduce_minBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minS_rule: {
      vreduce_minSNode *node = new vreduce_minSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minI_rule: {
      vreduce_minINode *node = new vreduce_minINode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minL_rule: {
      vreduce_minLNode *node = new vreduce_minLNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxF_rule: {
      vreduce_maxFNode *node = new vreduce_maxFNode();
      node->set_opnd_array(3, MachOperGenerator(FREGF));
      node->set_opnd_array(4, MachOperGenerator(VREG));
      node->set_opnd_array(5, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_maxD_rule: {
      vreduce_maxDNode *node = new vreduce_maxDNode();
      node->set_opnd_array(3, MachOperGenerator(FREGD));
      node->set_opnd_array(4, MachOperGenerator(VREG));
      node->set_opnd_array(5, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minF_rule: {
      vreduce_minFNode *node = new vreduce_minFNode();
      node->set_opnd_array(3, MachOperGenerator(FREGF));
      node->set_opnd_array(4, MachOperGenerator(VREG));
      node->set_opnd_array(5, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vreduce_minD_rule: {
      vreduce_minDNode *node = new vreduce_minDNode();
      node->set_opnd_array(3, MachOperGenerator(FREGD));
      node->set_opnd_array(4, MachOperGenerator(VREG));
      node->set_opnd_array(5, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateB_rule: {
      replicateBNode *node = new replicateBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateS_rule: {
      replicateSNode *node = new replicateSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateI_rule: {
      replicateINode *node = new replicateINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateL_rule: {
      replicateLNode *node = new replicateLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateB_imm5_rule: {
      replicateB_imm5Node *node = new replicateB_imm5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateS_imm5_rule: {
      replicateS_imm5Node *node = new replicateS_imm5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateI_imm5_rule: {
      replicateI_imm5Node *node = new replicateI_imm5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateL_imm5_rule: {
      replicateL_imm5Node *node = new replicateL_imm5Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateF_rule: {
      replicateFNode *node = new replicateFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case replicateD_rule: {
      replicateDNode *node = new replicateDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrB_rule: {
      vasrBNode *node = new vasrBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrS_rule: {
      vasrSNode *node = new vasrSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrI_rule: {
      vasrINode *node = new vasrINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrL_rule: {
      vasrLNode *node = new vasrLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslB_rule: {
      vlslBNode *node = new vlslBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslS_rule: {
      vlslSNode *node = new vlslSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslI_rule: {
      vlslINode *node = new vlslINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslL_rule: {
      vlslLNode *node = new vlslLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrB_rule: {
      vlsrBNode *node = new vlsrBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrS_rule: {
      vlsrSNode *node = new vlsrSNode();
      node->set_opnd_array(3, MachOperGenerator(VREG));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrI_rule: {
      vlsrINode *node = new vlsrINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrL_rule: {
      vlsrLNode *node = new vlsrLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrB_imm_rule: {
      vasrB_immNode *node = new vasrB_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrS_imm_rule: {
      vasrS_immNode *node = new vasrS_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrI_imm_rule: {
      vasrI_immNode *node = new vasrI_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vasrL_imm_rule: {
      vasrL_immNode *node = new vasrL_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrB_imm_rule: {
      vlsrB_immNode *node = new vlsrB_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrS_imm_rule: {
      vlsrS_immNode *node = new vlsrS_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrI_imm_rule: {
      vlsrI_immNode *node = new vlsrI_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlsrL_imm_rule: {
      vlsrL_immNode *node = new vlsrL_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslB_imm_rule: {
      vlslB_immNode *node = new vlslB_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslS_imm_rule: {
      vlslS_immNode *node = new vlslS_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslI_imm_rule: {
      vlslI_immNode *node = new vlslI_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vlslL_imm_rule: {
      vlslL_immNode *node = new vlslL_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntB_rule: {
      vshiftcntBNode *node = new vshiftcntBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntB_0_rule: {
      vshiftcntB_0Node *node = new vshiftcntB_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntS_rule: {
      vshiftcntSNode *node = new vshiftcntSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntS_0_rule: {
      vshiftcntS_0Node *node = new vshiftcntS_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntI_rule: {
      vshiftcntINode *node = new vshiftcntINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntI_0_rule: {
      vshiftcntI_0Node *node = new vshiftcntI_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntL_rule: {
      vshiftcntLNode *node = new vshiftcntLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vshiftcntL_0_rule: {
      vshiftcntL_0Node *node = new vshiftcntL_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrtF_rule: {
      vsqrtFNode *node = new vsqrtFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsqrtD_rule: {
      vsqrtDNode *node = new vsqrtDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubB_rule: {
      vsubBNode *node = new vsubBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubS_rule: {
      vsubSNode *node = new vsubSNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubI_rule: {
      vsubINode *node = new vsubINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubL_rule: {
      vsubLNode *node = new vsubLNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubF_rule: {
      vsubFNode *node = new vsubFNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsubD_rule: {
      vsubDNode *node = new vsubDNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vstring_equalsL_rule: {
      vstring_equalsLNode *node = new vstring_equalsLNode();
      node->set_opnd_array(4, MachOperGenerator(VREG_V1));
      node->set_opnd_array(5, MachOperGenerator(VREG_V2));
      node->set_opnd_array(6, MachOperGenerator(VREG_V3));
      return node;
    }
  case vstring_equalsU_rule: {
      vstring_equalsUNode *node = new vstring_equalsUNode();
      node->set_opnd_array(4, MachOperGenerator(VREG_V1));
      node->set_opnd_array(5, MachOperGenerator(VREG_V2));
      node->set_opnd_array(6, MachOperGenerator(VREG_V3));
      return node;
    }
  case varray_equalsB_rule: {
      varray_equalsBNode *node = new varray_equalsBNode();
      node->set_opnd_array(3, MachOperGenerator(VREG_V1));
      node->set_opnd_array(4, MachOperGenerator(VREG_V2));
      node->set_opnd_array(5, MachOperGenerator(VREG_V3));
      return node;
    }
  case varray_equalsC_rule: {
      varray_equalsCNode *node = new varray_equalsCNode();
      node->set_opnd_array(3, MachOperGenerator(VREG_V1));
      node->set_opnd_array(4, MachOperGenerator(VREG_V2));
      node->set_opnd_array(5, MachOperGenerator(VREG_V3));
      return node;
    }
  case vstring_compareU_rule: {
      vstring_compareUNode *node = new vstring_compareUNode();
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(VREG_V4));
      node->set_opnd_array(9, MachOperGenerator(VREG_V5));
      return node;
    }
  case vstring_compareL_rule: {
      vstring_compareLNode *node = new vstring_compareLNode();
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(VREG_V4));
      node->set_opnd_array(9, MachOperGenerator(VREG_V5));
      return node;
    }
  case vstring_compareUL_rule: {
      vstring_compareULNode *node = new vstring_compareULNode();
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(VREG_V4));
      node->set_opnd_array(9, MachOperGenerator(VREG_V5));
      return node;
    }
  case vstring_compareLU_rule: {
      vstring_compareLUNode *node = new vstring_compareLUNode();
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(VREG_V4));
      node->set_opnd_array(9, MachOperGenerator(VREG_V5));
      return node;
    }
  case vstring_inflate_rule: {
      vstring_inflateNode *node = new vstring_inflateNode();
      node->set_opnd_array(4, MachOperGenerator(VREG_V1));
      node->set_opnd_array(5, MachOperGenerator(VREG_V2));
      node->set_opnd_array(6, MachOperGenerator(VREG_V3));
      node->set_opnd_array(7, MachOperGenerator(IREGLNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vencode_iso_array_rule: {
      vencode_iso_arrayNode *node = new vencode_iso_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case vencode_ascii_array_rule: {
      vencode_ascii_arrayNode *node = new vencode_ascii_arrayNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case vstring_compress_rule: {
      vstring_compressNode *node = new vstring_compressNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(VREG_V1));
      node->set_opnd_array(6, MachOperGenerator(VREG_V2));
      node->set_opnd_array(7, MachOperGenerator(VREG_V3));
      node->set_opnd_array(8, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case vhas_negatives_rule: {
      vhas_negativesNode *node = new vhas_negativesNode();
      node->set_opnd_array(3, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(4, MachOperGenerator(VREG_V1));
      node->set_opnd_array(5, MachOperGenerator(VREG_V2));
      node->set_opnd_array(6, MachOperGenerator(VREG_V3));
      node->set_opnd_array(7, MachOperGenerator(IREGLNOSP));
      return node;
    }
  case vstringU_indexof_char_rule: {
      vstringU_indexof_charNode *node = new vstringU_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(VREG_V1));
      node->set_opnd_array(8, MachOperGenerator(VREG_V2));
      node->set_opnd_array(9, MachOperGenerator(VREG_V3));
      return node;
    }
  case vstringL_indexof_char_rule: {
      vstringL_indexof_charNode *node = new vstringL_indexof_charNode();
      node->set_opnd_array(4, MachOperGenerator(IREGI_R10));
      node->set_opnd_array(5, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(6, MachOperGenerator(IREGINOSP));
      node->set_opnd_array(7, MachOperGenerator(VREG_V1));
      node->set_opnd_array(8, MachOperGenerator(VREG_V2));
      node->set_opnd_array(9, MachOperGenerator(VREG_V3));
      return node;
    }
  case vclearArray_reg_reg_rule: {
      vclearArray_reg_regNode *node = new vclearArray_reg_regNode();
      node->set_opnd_array(3, MachOperGenerator(VREG_V1));
      node->set_opnd_array(4, MachOperGenerator(VREG_V2));
      node->set_opnd_array(5, MachOperGenerator(VREG_V3));
      return node;
    }
  case rorI_imm_b_rule: {
      rorI_imm_bNode *node = new rorI_imm_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorL_imm_b_rule: {
      rorL_imm_bNode *node = new rorL_imm_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorI_reg_b_rule: {
      rorI_reg_bNode *node = new rorI_reg_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rorL_reg_b_rule: {
      rorL_reg_bNode *node = new rorL_reg_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rolI_reg_b_rule: {
      rolI_reg_bNode *node = new rolI_reg_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case rolL_reg_b_rule: {
      rolL_reg_bNode *node = new rolL_reg_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case convP2I_b_rule: {
      convP2I_bNode *node = new convP2I_bNode();
      return node;
    }
  case convB2I_reg_reg_b_rule: {
      convB2I_reg_reg_bNode *node = new convB2I_reg_reg_bNode();
      return node;
    }
  case convI2S_reg_reg_b_rule: {
      convI2S_reg_reg_bNode *node = new convI2S_reg_reg_bNode();
      return node;
    }
  case convS2UI_reg_reg_b_rule: {
      convS2UI_reg_reg_bNode *node = new convS2UI_reg_reg_bNode();
      return node;
    }
  case convI2UL_reg_reg_b_rule: {
      convI2UL_reg_reg_bNode *node = new convI2UL_reg_reg_bNode();
      return node;
    }
  case bytes_reverse_int_b_rule: {
      bytes_reverse_int_bNode *node = new bytes_reverse_int_bNode();
      return node;
    }
  case bytes_reverse_long_b_rule: {
      bytes_reverse_long_bNode *node = new bytes_reverse_long_bNode();
      return node;
    }
  case bytes_reverse_unsigned_short_b_rule: {
      bytes_reverse_unsigned_short_bNode *node = new bytes_reverse_unsigned_short_bNode();
      return node;
    }
  case bytes_reverse_short_b_rule: {
      bytes_reverse_short_bNode *node = new bytes_reverse_short_bNode();
      return node;
    }
  case shaddP_reg_reg_b_rule: {
      shaddP_reg_reg_bNode *node = new shaddP_reg_reg_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shaddP_reg_reg_ext_b_rule: {
      shaddP_reg_reg_ext_bNode *node = new shaddP_reg_reg_ext_bNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case shaddL_reg_reg_b_rule: {
      shaddL_reg_reg_bNode *node = new shaddL_reg_reg_bNode();
      return node;
    }
  case shaddL_reg_reg_b_0_rule: {
      shaddL_reg_reg_b_0Node *node = new shaddL_reg_reg_b_0Node();
      return node;
    }
  case shaddL_reg_reg_ext_b_rule: {
      shaddL_reg_reg_ext_bNode *node = new shaddL_reg_reg_ext_bNode();
      return node;
    }
  case shaddL_reg_reg_ext_b_0_rule: {
      shaddL_reg_reg_ext_b_0Node *node = new shaddL_reg_reg_ext_b_0Node();
      return node;
    }
  case countLeadingZerosI_b_rule: {
      countLeadingZerosI_bNode *node = new countLeadingZerosI_bNode();
      return node;
    }
  case countLeadingZerosL_b_rule: {
      countLeadingZerosL_bNode *node = new countLeadingZerosL_bNode();
      return node;
    }
  case countTrailingZerosI_b_rule: {
      countTrailingZerosI_bNode *node = new countTrailingZerosI_bNode();
      return node;
    }
  case countTrailingZerosL_b_rule: {
      countTrailingZerosL_bNode *node = new countTrailingZerosL_bNode();
      return node;
    }
  case popCountI_b_rule: {
      popCountI_bNode *node = new popCountI_bNode();
      return node;
    }
  case popCountL_b_rule: {
      popCountL_bNode *node = new popCountL_bNode();
      return node;
    }
  case minI_reg_reg_b_rule: {
      minI_reg_reg_bNode *node = new minI_reg_reg_bNode();
      return node;
    }
  case maxI_reg_reg_b_rule: {
      maxI_reg_reg_bNode *node = new maxI_reg_reg_bNode();
      return node;
    }
  case minI_reg_zero_b_rule: {
      minI_reg_zero_bNode *node = new minI_reg_zero_bNode();
      return node;
    }
  case minI_reg_zero_b_0_rule: {
      minI_reg_zero_b_0Node *node = new minI_reg_zero_b_0Node();
      return node;
    }
  case maxI_reg_zero_b_rule: {
      maxI_reg_zero_bNode *node = new maxI_reg_zero_bNode();
      return node;
    }
  case maxI_reg_zero_b_0_rule: {
      maxI_reg_zero_b_0Node *node = new maxI_reg_zero_b_0Node();
      return node;
    }
  case absI_reg_b_rule: {
      absI_reg_bNode *node = new absI_reg_bNode();
      return node;
    }
  case absL_reg_b_rule: {
      absL_reg_bNode *node = new absL_reg_bNode();
      return node;
    }
  case andnI_reg_reg_b_rule: {
      andnI_reg_reg_bNode *node = new andnI_reg_reg_bNode();
      return node;
    }
  case andnI_reg_reg_b_0_rule: {
      andnI_reg_reg_b_0Node *node = new andnI_reg_reg_b_0Node();
      return node;
    }
  case andnL_reg_reg_b_rule: {
      andnL_reg_reg_bNode *node = new andnL_reg_reg_bNode();
      return node;
    }
  case andnL_reg_reg_b_0_rule: {
      andnL_reg_reg_b_0Node *node = new andnL_reg_reg_b_0Node();
      return node;
    }
  case ornI_reg_reg_b_rule: {
      ornI_reg_reg_bNode *node = new ornI_reg_reg_bNode();
      return node;
    }
  case ornI_reg_reg_b_0_rule: {
      ornI_reg_reg_b_0Node *node = new ornI_reg_reg_b_0Node();
      return node;
    }
  case ornL_reg_reg_b_rule: {
      ornL_reg_reg_bNode *node = new ornL_reg_reg_bNode();
      return node;
    }
  case ornL_reg_reg_b_0_rule: {
      ornL_reg_reg_b_0Node *node = new ornL_reg_reg_b_0Node();
      return node;
    }
  case convI2Bool_andI_reg_immIpowerOf2_rule: {
      convI2Bool_andI_reg_immIpowerOf2Node *node = new convI2Bool_andI_reg_immIpowerOf2Node();
      return node;
    }
  case compareAndSwapP_shenandoah_rule: {
      compareAndSwapP_shenandoahNode *node = new compareAndSwapP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case compareAndSwapN_shenandoah_rule: {
      compareAndSwapN_shenandoahNode *node = new compareAndSwapN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case compareAndSwapPAcq_shenandoah_rule: {
      compareAndSwapPAcq_shenandoahNode *node = new compareAndSwapPAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case compareAndSwapNAcq_shenandoah_rule: {
      compareAndSwapNAcq_shenandoahNode *node = new compareAndSwapNAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case compareAndExchangeN_shenandoah_rule: {
      compareAndExchangeN_shenandoahNode *node = new compareAndExchangeN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangeP_shenandoah_rule: {
      compareAndExchangeP_shenandoahNode *node = new compareAndExchangeP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapN_shenandoah_rule: {
      weakCompareAndSwapN_shenandoahNode *node = new weakCompareAndSwapN_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case compareAndExchangeNAcq_shenandoah_rule: {
      compareAndExchangeNAcq_shenandoahNode *node = new compareAndExchangeNAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGNNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndExchangePAcq_shenandoah_rule: {
      compareAndExchangePAcq_shenandoahNode *node = new compareAndExchangePAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->set_opnd_array(5, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case weakCompareAndSwapP_shenandoah_rule: {
      weakCompareAndSwapP_shenandoahNode *node = new weakCompareAndSwapP_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case weakCompareAndSwapNAcq_shenandoah_rule: {
      weakCompareAndSwapNAcq_shenandoahNode *node = new weakCompareAndSwapNAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGNNOSP));
      return node;
    }
  case weakCompareAndSwapPAcq_shenandoah_rule: {
      weakCompareAndSwapPAcq_shenandoahNode *node = new weakCompareAndSwapPAcq_shenandoahNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      return node;
    }
  case zLoadP_rule: {
      zLoadPNode *node = new zLoadPNode();
      node->set_opnd_array(2, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zCompareAndSwapP_rule: {
      zCompareAndSwapPNode *node = new zCompareAndSwapPNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case zCompareAndSwapP_0_rule: {
      zCompareAndSwapP_0Node *node = new zCompareAndSwapP_0Node();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case zCompareAndSwapPAcq_rule: {
      zCompareAndSwapPAcqNode *node = new zCompareAndSwapPAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case zCompareAndSwapPAcq_0_rule: {
      zCompareAndSwapPAcq_0Node *node = new zCompareAndSwapPAcq_0Node();
      node->set_opnd_array(4, MachOperGenerator(IREGINOSP));
      return node;
    }
  case zCompareAndExchangeP_rule: {
      zCompareAndExchangePNode *node = new zCompareAndExchangePNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zCompareAndExchangePAcq_rule: {
      zCompareAndExchangePAcqNode *node = new zCompareAndExchangePAcqNode();
      node->set_opnd_array(4, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zGetAndSetP_rule: {
      zGetAndSetPNode *node = new zGetAndSetPNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case zGetAndSetPAcq_rule: {
      zGetAndSetPAcqNode *node = new zGetAndSetPAcqNode();
      node->set_opnd_array(3, MachOperGenerator(IREGPNOSP));
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DRISCV64=1
#ifndef RISCV64
#  error "RISCV64 must be defined"
#endif // RISCV64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
